import smbus
import apds9300
import sys
import time

def screen_pos(x, y):
	sys.stdout.write(("\033[%u;%uH" % (y, x)))

def screen_clear():
	print("\n" * 80)

bus = smbus.SMBus(1)
# integration:
# 0:  13,7 ms
# 1: 101   ms
# 2: 402   ms

highgain = True
integration = 1

s = apds9300.adps9300(bus, highgain, integration);

while True:
	ch0, ch1 = s.read_raw()
	apdslux = s.calc_lux(ch0, ch1)
	if apdslux == None:
		apdslux = 0
	
	print("{0:>5}  {1:>5}  {2:>8.3f}".format(ch0, ch1, apdslux));
	time.sleep(0.5);
