﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.IO;

namespace ALScalib
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        MinoltaT10 m = null;//new MinoltaT10("COM4");
        RigolDP800 r = null;//new RigolDP800("USB0::0x1AB1::0x0E11::DPxxxxxxxxxxx::INSTR");
        ADPS9300 a = new ADPS9300();
        System.Windows.Forms.Timer tmrRead;

        private void button1_Click(object sender, EventArgs e)
        {

            ADPS9300.IntegrationTime itime = ADPS9300.IntegrationTime.I101ms;

            switch (cboIntegrationTime.Text)
            {
                case "13,7 ms":
                    itime = ADPS9300.IntegrationTime.I13_7ms;
                    break;
                case "101 ms":
                    itime = ADPS9300.IntegrationTime.I101ms;
                    break;
                case "402 ms":
                    itime = ADPS9300.IntegrationTime.I402ms;
                    break;
            }

            bool highgain = chkHighGain.Checked;


            a.Config(highgain, itime);
            a.SetPower(true);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            tmrRead.Enabled = false;
            
            m.PCMode(0);
            StreamWriter sw = new StreamWriter("meas.csv");
            sw.WriteLine("sep=\t");
            string[] cols = new string[] { 
                "U [V]", 
                "I [A]", 
                "lum_ref [lux]", 
                "Gain", 
                "tint [ms]", 
                "Ch0", 
                "Ch1", 
                "tlum_dut [lux]" 
            };
            sw.WriteLine(string.Join("\t", cols));
            r.CurrentChannel = 1;
            r.Current = 1.2;
            r.Voltage = 0;
            r.OutputEnabled = true;

            RunMeasurement(sw, false, ADPS9300.IntegrationTime.I13_7ms);
            RunMeasurement(sw, false, ADPS9300.IntegrationTime.I101ms);
            RunMeasurement(sw, false, ADPS9300.IntegrationTime.I402ms);
            RunMeasurement(sw, true, ADPS9300.IntegrationTime.I13_7ms);
            RunMeasurement(sw, true, ADPS9300.IntegrationTime.I101ms);
            RunMeasurement(sw, true, ADPS9300.IntegrationTime.I402ms);
            
            r.OutputEnabled = false;
            sw.Flush();
            sw.Close();
        }

        private void RunMeasurement(StreamWriter sw, bool highgain, ADPS9300.IntegrationTime tint)
        {

            a.Config(highgain, tint);

            for (double i = 7; i <= 12; i += 0.1)
            {
                r.Voltage = i;
                Thread.Sleep(2000);
                double lux = m.ReadIlluminance(0);
                ADPS9300.SensorData sd = a.ReadSensordata();

                sw.WriteLine("{0}\t{1}\t{2}\t{3}\t{4}\t{5}\t{6   }\t{7:0.00}", r.MeasVoltage, r.MeasCurrent, lux, highgain ? 16 : 1, tint.ToString(), sd.Ch0, sd.Ch1, sd.Luminance);

            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            tmrRead = new System.Windows.Forms.Timer();
            tmrRead.Tick += new EventHandler(tmrRead_Tick);
            tmrRead.Interval = 500;
            tmrRead.Enabled = true;

            a.Config(false, ADPS9300.IntegrationTime.I101ms);
            a.SetPower(true);
        }

        void tmrRead_Tick(object sender, EventArgs e)
        {
            
            ADPS9300.SensorData sd = a.ReadSensordata();

            label1.Text = string.Format("Ch0: {0}", sd.Ch0);
            label2.Text = string.Format("Ch1: {0}", sd.Ch1);
            label3.Text = string.Format("Lum: {0:0.000} lx", sd.Luminance);
        }
    }
}
