﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NationalInstruments.VisaNS;
using System.Globalization;

namespace ALScalib
{
    public class RigolDP800
    {
        MessageBasedSession mbs = null;

        public RigolDP800(string resourcename)
        {
            mbs = new MessageBasedSession(resourcename);


        }

        public int CurrentChannel
        {
            get
            {
                return (int)(mbs.Query("INST?")[2]);
            }
            set
            {
                mbs.Write(string.Format("INST CH{0}", value));
            }
        }

        public double Voltage
        {
            get
            {
                string str = mbs.Query("VOLT?");
                return double.Parse(str, CultureInfo.InvariantCulture);
            }
            set
            {
                mbs.Write(string.Format("VOLT {0}", value.ToString(CultureInfo.InvariantCulture)));
            }
        }

        public double MeasVoltage
        {
            get
            {
                string str = mbs.Query("MEAS:VOLT?");
                return double.Parse(str, CultureInfo.InvariantCulture);
            }
        }

        public double Current
        {
            get
            {
                string str = mbs.Query("CURR?");
                return double.Parse(str, CultureInfo.InvariantCulture);
            }
            set
            {
                mbs.Write(string.Format("CURR {0}", value.ToString(CultureInfo.InvariantCulture)));
            }
        }

        public double MeasCurrent
        {
            get
            {
                string str = mbs.Query("MEAS:CURR?");
                return double.Parse(str, CultureInfo.InvariantCulture);
            }
        }

        public bool OutputEnabled
        {
            get
            {
                string str = mbs.Query("OUTP?");
                if (str == "OFF")
                {
                    return false;
                }
                else if (str == "ON")
                {
                    return true;
                }
                else
                {
                    throw new Exception("Unable to retrieve output state");
                }
            }
            set
            {
                mbs.Write(string.Format("OUTP {0}", value ? "ON" : "OFF"));
            }
        }
    }
}
